package webdb.sample {
    
    //[RemoteClass(alias="sample.models.Book")]
    public class Book {
        
        /** タイトル */
        public var title:String;
        /** 本体価格 */
        public var price:uint;
        /** Authorオブジェクト配列 */
        public var authors:Array;
        
        /** コンストラクタ */
        public function Book(){}
        
        /** 税込みの定価を返します。 */
        public function get taxedPrice():uint {
            return price * 1.05;
        }
        
        /** 複数の著者がいる場合に、著者名を「、」区切りの文字列で返します。 */
        public function get author():String {
            var names:String = '';
            for each(var a:Author in authors) {
                names += a.name + "、";
            }
            return names.substr(0, -1);
        }

        public function toString():String {
            var sb:String = "Book(";
            sb += "title='" + title + "', ";
            sb += "author='" + author + "', ";
            sb += "price='" + price + "', ";
            sb += "taxedPrice='" + taxedPrice + "')";
            return sb;
        }
    }
}